//
// Created by zoe on 3/06/23.
//

#include "SentecSolarRadiationSensor.h"

String SEM228A::getSolarRadiationStr() {
    return getValueStr((int)glob);
}

void SEM228A::setup() {
    // TODO: check if rs485 serial is active
}

out_data_solar_radiation SEM228A::readData() {
    auto error = readRegister(0, 1);
    glob = word(answerFrame[3], answerFrame[4]);
    ESP_LOGI("SolarRadiation", "Global solar radiation: %d W/m^2", glob);
    return {static_cast<float>(glob), error};
}
std::list<Message> SEM228A::buildMessages() {
    auto messages = std::list<Message>();
    auto data = readData();
    Measurement solarRadiation{data.solarRadiation, address, NO_I2C_ADDRESS, MeasurementType::SOLAR_RADIATION,
                               data.solarError};
    messages.emplace_back(Message{solarRadiation, getSensorInformation(), Time::getInstance().getEpochSeconds()});
    return messages;
}

SensorInformation SEM228A::getSensorInformation() const {
    return SensorInformation(HardwareName::SEM228A, SensorProtocol::RS485);
}
