//
// Created by zoe on 2/2/23.
//

#ifndef CLIENT_MOCK_ERRORTYPES_H
#define CLIENT_MOCK_ERRORTYPES_H

#include <string>

enum class ErrorType: char {
  SENSOR_NOT_FOUND,
  SENSOR_INIT_FAILED,
  SENSOR_NOT_CONNECTED,
  SEM404_COULD_NOT_RESET_PRECIPITATION,
  NO_DATA,
  DATA_OK,
  NULL_MESSAGE, // message that is sent as padding, should be thrown away
  SENSOR_DOES_NOT_RETURN_DATA,
  BATTERY_VOLTAGE_TOO_LOW,
  INVALID_VALUE,
  INA219_OVERFLOW,
  CONNECTION_ENDED_PREMATURELY, // connection ended prematurely
  WRONG_CRC, // corrupted data package
  UNKNOWN,
};

namespace ErrorTypes {
std::string errorTypeToString(ErrorType errorType);
}


#endif //CLIENT_MOCK_ERRORTYPES_H
