//
// Created by cynthya on 10/6/22.
//

#ifndef CLIENT_SENSORINFORMATION_HPP
#define CLIENT_SENSORINFORMATION_HPP

#include "SensorProtocol.hpp"
#include <string>
#include <HardwareNames.h>

class SensorInformation {
 public:
  SensorInformation(HardwareName hardwareName, SensorProtocol sensorProtocol)
      : hardwareName(hardwareName), sensorProtocol(sensorProtocol) {
  }

  [[nodiscard]] const HardwareName &
  getHardwareName() const { return hardwareName; }
  [[nodiscard]] std::string getHardwareNameString() const {
    return HardwareNames::hardwareNameToString(hardwareName);
  }
  [[nodiscard]] SensorProtocol getProtocol() const { return sensorProtocol; }
  [[nodiscard]] std::string getProtocolString() const {
    return SensorProtocols::sensorProtocolToString(sensorProtocol);
  }

 private:
  HardwareName hardwareName;
  SensorProtocol sensorProtocol;
};

#endif // CLIENT_SENSORINFORMATION_HPP
